<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="UTF-8">
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
	<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
	<title>task 41.55</title>
	<!-- Import Datatable sau jquery -->
	<!-- Import them style bootstrap cho datatable -->
	<link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
	<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
	<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body>
	<div class="container">
		<h2 style="text-align: center;">Danh Sách Các Đơn Hàng</h2>
		<div class="jumbotron container">
			<div class="row form-group">
				<div class="col-md-5 row">
					<div class="col-md-6 text-center">
						<label class="form-group mx-2">trạng thái order</label>
					</div>
					<div class="col-md-6">
						<select class="form-control" id="select-status">
							<option value="All">All</option>
							<option value="Open">Open</option>
							<option value="Confirmed">Confirmed</option>
							<option value="Cancel">Cancel</option>
						</select>
					</div>
				</div>
				<div class="col-md-5 row">
					<div class="col-md-6 text-center">
						<label class="form-group mx-2">loại pizza</label>
					</div>
					<div class="col-md-6">
						<select class="form-control" id="select-pizza">
							<option value="All">All</option>
							<option value="Hawaii">Hawaii</option>
							<option value="Bacon">Bacon</option>
							<option value="Seafood">Seafood</option>
						</select>
					</div>
				</div>
				<div class="col-md-2 row">
					<div class="col-md-12 text-right">
						<button class="btn btn-success" id="btn-filter">Lọc</button>
					</div>
				</div>
			</div>
		</div>
		<table class="table table-bordered table-striped table-hover" id="order-table">
			<thead>
				<tr>
					<th>Order Code</th>
					<th>Kích cỡ combo</th>
					<th>Loại Pizza</th>
					<th>Nước uống</th>
					<th>Thành tiền</th>
					<th>Họ và tên</th>
					<th>Số điện thoại</th>
					<th>Trạng thái</th>
					<th>Action</th>
				</tr>
			</thead>
		</table>
	</div>
<!---Modal Details-->
<div id="detail-modal" class="modal fade" tabindex="-1">
	<div class="modal-dialog">
		<div class="modal-content">
			<div class="modal-header">
				<h5 class="modal-title">Order Details...!</h5>
				<button type="button" class="close" data-dismiss="modal">&times;</button>
			</div>
			<div class="modal-body">
				<div class="row form-group">
					<div class="col-sm-3">
						<label>01.Order Code</label>
					</div>
					<div class="col-sm-9">
						<input id="inp-orderCode" type="text" class="form-control"/>
					</div>
				</div>
				<div class="row form-group">
					<div class="col-sm-3">
						<label>02.Pizza Size</label>
					</div>
					<div class="col-sm-9">
						<select id="select-pizzaSize" class="form-control" type="text" ></select>
					</div>
				</div>
				<div class="row form-group">
					<div class="col-sm-3">
						<label>03.Đường kính</label>
					</div>
					<div class="col-sm-9">
						<input id="inp-duongKinh" type="text" class="form-control"/>
					</div>
				</div>
				<div class="row form-group">
					<div class="col-sm-3">
						<label>04.Sườn</label>
					</div>
					<div class="col-sm-9">
						<input id="inp-suon" type="text" class="form-control"/>
					</div>
				</div>
				<div class="row form-group">
					<div class="col-sm-3">
						<label>05.Salad</label>
					</div>
					<div class="col-sm-9">
						<input id="inp-salad" type="text" class="form-control"/>
					</div>
				</div>
				<div class="row form-group">
					<div class="col-sm-3">
						<label>06.Pizza Type</label>
					</div>
					<div class="col-sm-9">
						<input id="inp-pizzaType" type="text" class="form-control"/>
					</div>
				</div>
				<div class="row form-group">
					<div class="col-sm-3">
						<label>07.ID Voucher</label>
					</div>
					<div class="col-sm-9">
						<input id="inp-idVoucher" type="text" class="form-control"/>
					</div>
				</div>
				<div class="row form-group">
					<div class="col-sm-3">
						<label>08.Thành tiền</label>
					</div>
					<div class="col-sm-9">
						<input id="inp-price" type="text" class="form-control"/>
					</div>
				</div>
				<div class="row form-group">
					<div class="col-sm-3">
						<label>09.Giảm giá</label>
					</div>
					<div class="col-sm-9">
						<input id="inp-discount" type="text" class="form-control"/>
					</div>
				</div>
				<div class="row form-group">
					<div class="col-sm-3">
						<label>10.Loại đồ uống</label>
					</div>
					<div class="col-sm-9">
						<select id="select-idLoaiNuocUong" class="form-control" type="text"></select>
					</div>
				</div>
				<div class="row form-group">
					<div class="col-sm-3">
						<label>11.Số Lượng nước uống</label>
					</div>
					<div class="col-sm-9">
						<input id="inp-soLuongNuocUong" type="text" class="form-control"/>
					</div>
				</div>
				<div class="row form-group">
					<div class="col-sm-3">
						<label>12.Họ và Tên</label>
					</div>
					<div class="col-sm-9">
						<input id="inp-fullname" type="text" class="form-control"/>
					</div>
				</div>
				<div class="row form-group">
					<div class="col-sm-3">
						<label>13. Email</label>
					</div>
					<div class="col-sm-9">
						<input id="inp-email" type="text" class="form-control"/>
					</div>
				</div>
				<div class="row form-group">
					<div class="col-sm-3">
						<label>14.Số điện thoại</label>
					</div>
					<div class="col-sm-9">
						<input id="inp-soDienThoai" type="text" class="form-control"/>
					</div>
				</div>
				<div class="row form-group">
					<div class="col-sm-3">
						<label>15.Địa chỉ</label>
					</div>
					<div class="col-sm-9">
						<input id="inp-diaChi" type="text" class="form-control"/>
					</div>
				</div>
				<div class="row form-group">
					<div class="col-sm-3">
						<label>16.Lời Nhắn</label>
					</div>
					<div class="col-sm-9">
						<input id="inp-loiNhan" type="text" class="form-control"/>
					</div>
				</div>
				<div class="row form-group">
					<div class="col-sm-3">
						<label>17.Ngày Order</label>
					</div>
					<div class="col-sm-9">
						<input id="inp-ngayTao" type="text" class="form-control"/>
					</div>
				</div>
				<div class="row form-group">
					<div class="col-sm-3">
						<label>18.Ngày chỉnh sửa</label>
					</div>
					<div class="col-sm-9">
						<input id="inp-ngayUpdate" type="text" class="form-control"/>
					</div>
				</div>
				<div class="row form-group">
					<div class="col-sm-6">
						<button id="btn-confirm" class="col-sm-12 btn btn-warning">Confirm</button>
					</div>
					<div class="col-sm-6">
						<button id="btn-cancel" class="col-sm-12 btn btn-danger">Cancel</button>
					</div>
				</div>
								
			
			</div>
			<div class="modal-footer">
				<button type="button" id="btn-modal-close" class="btn btn-primary">Close</button>
			</div>
		</div>
	</div>
</div>

</body>
<script>
	"use strict";
	const gREQUEST_STATUS_OK = 200;
	const gREQUEST_CREATE_OK = 201; // status 201 tạo thành công
	const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
	// gọi mẫu danh sách order
	function onBtnGetAllOrderClick() {
		// base url
		const vBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
		// creat a request
		var vXmlHttpGetAllOrder = new XMLHttpRequest();
		vXmlHttpGetAllOrder.open("GET", vBASE_URL, true);
		vXmlHttpGetAllOrder.send();
		vXmlHttpGetAllOrder.onreadystatechange = function () {
			if(this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
				var vOrderList = vXmlHttpGetAllOrder.resposeText;
				console.log(vOrderList);
			}
		}
	}
	$(document).ready(function() {
		/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
		var gDataOrders = []; // khai báo biến mảng (biến toàn cục) để chứa thông tin đơn hàng
		var gOrderEdit="";
		var gId;
		var gTrangThai="";
		var gOrderCode;
		var gPizza_Size=["S","M","L"]; //khai báo mảng Size để đưa vào ô select modal
		const gCOLUMN = ["orderCode", "kichCo", "loaiPizza", "idLoaiNuocUong", "thanhTien", "hoTen", "soDienThoai", "trangThai", "action"];
		// khai báo các cột của datatable
		const gCOLUMN_ORDER_CODE = 0;
		const gCOLUMN_KICH_CO_COMBO= 1;
		const gCOLUMN_LOAI_PIZZA= 2;
		const gCOLUMN_NUOC_UONG= 3;
		const gCOLUMN_THANH_TIEN= 4;
		const gCOLUMN_HO_VA_TEN= 5;
		const gCOLUMN_SO_DIEN_THOAI= 6;
		const gCOLUMN_TRANG_THAI= 7;
		const gCOLUMN_ACTION= 8;
		// định nghĩa table chưa có data
		$("#order-table").DataTable({
			"columns": [
				{ "data": gCOLUMN[gCOLUMN_ORDER_CODE] },
				{ "data": gCOLUMN[gCOLUMN_KICH_CO_COMBO] },
				{ "data": gCOLUMN[gCOLUMN_LOAI_PIZZA] },
				{ "data": gCOLUMN[gCOLUMN_NUOC_UONG] },
				{ "data": gCOLUMN[gCOLUMN_THANH_TIEN] },
				{ "data": gCOLUMN[gCOLUMN_HO_VA_TEN] },
				{ "data": gCOLUMN[gCOLUMN_SO_DIEN_THOAI] },
				{ "data": gCOLUMN[gCOLUMN_TRANG_THAI] },
				{ "data": gCOLUMN[gCOLUMN_ACTION] },
			],
			// ghi đè nội dung của cột action, chuyển thành button chi tiết
			"columnDefs": [
				{
					"targets": gCOLUMN_ACTION,
					"defaultContent": "<button class='btn-chitiet btn btn-primary'>chi tiết</button>"
				}]
		});
		/*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
		// hàm tải trang
		onPageLoading();
		// gán event handler (sự kiện) cho nút chi tiết
		$("#order-table").on("click", ".btn-chitiet", function() {
			onBtnChiTietClick(this); // this là button được ấn
		});
		// gán event handler (sự kiện) cho nút lọc
		$(document).on("click", "#btn-filter", function() {
			onBtnFilterDataClick(this); // this là button được ấn
		});
		$(document).on("click", "#btn-modal-close", function(){
			$("#detail-modal").modal("hide");
			location.reload();
		});
		$("#btn-confirm").on("click",function(){
			gTrangThai="confirmed";
			putUpdateOrder();
			
		});
		$("#btn-cancel").on("click",function(){
			gTrangThai="cancel";
			putUpdateOrder();
		});
		/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiệnilter */
		// hàm tải trang
		function onPageLoading() {
			// lấy data từ server
			$.ajax({
				url: "http://203.171.20.210:8080/devcamp-pizza365/orders",
				type: "GET",
				dataType: 'json',
				success: function(responseObject) {
					gDataOrders = responseObject;
					console.log(gDataOrders);
					// gọi hàm load đổ dữ liệu vào bảng
					loadDataToTable(responseObject);
				},
				error: function(error) {
					console.assert(error.responseText);
				}
			});
			getDrinkListFormServer();
			getPizzaSizes(gPizza_Size);// lấy pizza Size từ dữ liệu đã khai báo phía trên
		}
		function putUpdateOrder(){
			console.log(gId);
			var vObjectRequest={
				trangThai:gTrangThai
			}
			$.ajax({
				url: "http://203.171.20.210:8080/devcamp-pizza365/orders/"+gId ,
				type: "PUT",
				contentType: "application/json; charset-UTF-8",
				data: JSON.stringify(vObjectRequest),
				success: function(resOrderUpdate) {
					//ghi Order đó ra console xem thử
					console.log(resOrderUpdate);
					// gọi hàm load đổ dữ liệu vào bảng modal detail
					//handleResOrder(resOrderUpdate);
				},
				error: function(error) {
					console.assert(error.responseText);
				}
			});
		}
		// function onBtnCancelClick(){
		// 	var vObjectRequest={
		// 		trangThai:"cancel"
		// 	}
		// 	$.ajax({
		// 		url: "http://203.171.20.210:8080/devcamp-pizza365/orders/"+gId ,
		// 		type: "PUT",
		// 		contentType: "application/json; charset-UTF-8",
		// 		data: JSON.stringify(vObjectRequest),
		// 		success: function(resOrderUpdate) {
		// 			//ghi Order đó ra console xem thử
		// 			console.log(resOrderUpdate);
		// 			// gọi hàm load đổ dữ liệu vào bảng modal detail
		// 			//handleResOrder(resOrderUpdate);
		// 		},
		// 		error: function(error) {
		// 			console.assert(error.responseText);
		// 		}
		// 	});
		// }
		/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
		// hàm load đổ dữ liệu vào bảng
		function loadDataToTable(paramResponseObject) {
			var vUserTable = $("#order-table").DataTable();
			// xoá toàn bộ dữ liệu đang có của bảng
			vUserTable.clear();
			// cập nhật data chp vào bảng
			vUserTable.rows.add(paramResponseObject);
			// cập nhật lại giao diện hiển thị của bảng
			vUserTable.draw();
		}
		// hàm bấm nút chi tiết
		function onBtnChiTietClick(paramNutChiTiet) {
			var vUserTable = $("#order-table").DataTable();
			// xác định thẻ tr là cha của nút được chọn
			var vRowSelect = $(paramNutChiTiet).parents('tr');
			// lấy datatable row
			var vDataTableRow = vUserTable.row(vRowSelect);
			// lấy data của dòng
			var vUserData = vDataTableRow.data();
			console.log(vUserData);
			// var vId = vUserData.id;
			// var vOrderCode = vUserData.orderCode;
			// var vKichCoCombo = vUserData.kichCo;
			// var vLoaiPizza = vUserData.loaiPizza;
			// var vNuocUong = vUserData.idLoaiNuocUong;
			// var vThanhTien = vUserData.thanhTien;
			// var vHoVaTen = vUserData.hoTen;
			// var vSoDienThoai = vUserData.soDienThoai;
			// var vTrangThai = vUserData.trangThai;
			// console.log(vId);
			// console.log(vOrderCode);
			// console.log(vKichCoCombo);
			// console.log(vLoaiPizza);
			// console.log(vNuocUong);
			// console.log(vThanhTien);
			// console.log(vHoVaTen);
			// console.log(vSoDienThoai);
			// console.log(vTrangThai);
			$("#detail-modal").modal("show");
			gId=vUserData.id;
			gOrderCode=vUserData.orderCode;
			console.log(gId +" "+gOrderCode);
			getOrderInfoByOrderCode(gOrderCode);
		}
		// hàm nút lọc
		function onBtnFilterDataClick() {
			var vStatus = $("#select-status").val();
			var vPizzaType = $("#select-pizza").val();
			var vFilterResult = gDataOrders.filter(function(paramOrder, index) {
				return (vStatus === "All" || vStatus.toUpperCase() === paramOrder.trangThai.toUpperCase())
				&& (vPizzaType === "All" || vPizzaType.toUpperCase() === paramOrder.loaiPizza.toUpperCase())
			});
			console.log(vFilterResult);
			// gọi hàm load dữ liệu vào bảng
			loadDataToTable(vFilterResult);
		}
		//hàm lấy drinks list
		function getDrinkListFormServer(){
			$.ajax({
				url: "http://203.171.20.210:8080/devcamp-pizza365/drinks",
				type: "GET",
				dataType: 'json',
				success: function(resDrinks) {
					
					console.log(resDrinks);
					// gọi hàm load đổ dữ liệu vào bảng
					handleDrinksList(resDrinks);
				},
				error: function(error) {
					console.assert(error.responseText);
				}
			});
		}
		function handleDrinksList(paramDrinksList){
			$.each(paramDrinksList, function(i,item){
				$("#select-idLoaiNuocUong").append($(`<option>`,{
					text: item.tenNuocUong,
					value: item.maNuocUong,
				}));
			});
		}
		function getPizzaSizes(paramPizzaSize){
			$.each(paramPizzaSize, function(i,item){
				$("#select-pizzaSize").append($(`<option>`,{
					text: item,
					value: item.toLowerCase(),
				}));
			});
		}
		//lấy dữ liệu 1 order ra từ server (vì trên table hiển thị là không đủ)
		function getOrderInfoByOrderCode(paramOrderCode){
			$.ajax({
				url: "http://203.171.20.210:8080/devcamp-pizza365/orders/"+paramOrderCode ,
				type: "GET",
				dataType: 'json',
				success: function(resOrder) {
					//ghi Order đó ra console xem thử
					console.log(resOrder);
					gId=resOrder.id; //lấy thông tin Order để làm bước edit update
					// gọi hàm load đổ dữ liệu vào bảng modal detail
					handleResOrder(resOrder);
				},
				error: function(error) {
					console.assert(error.responseText);
				}
			});
		}
		function handleResOrder(paramResOrder){
			$("#inp-orderCode").val(paramResOrder.orderCode);
			$("#select-pizzaSize").val(paramResOrder.kichCo.toLowerCase());
			$("#inp-duongKinh").val(paramResOrder.duongKinh);
			$("#inp-suon").val(paramResOrder.suon);
			$("#inp-salad").val(paramResOrder.salad);

			$("#inp-pizzaType").val(paramResOrder.loaiPizza);
			$("#inp-idVoucher").val(paramResOrder.idVourcher);
			$("#inp-price").val(paramResOrder.thanhTien);
			$("#inp-discount").val(paramResOrder.giamGia);
			$("#select-idLoaiNuocUong").val(paramResOrder.idLoaiNuocUong);

			$("#inp-soLuongNuocUong").val(paramResOrder.soLuongNuoc);
			$("#inp-fullname").val(paramResOrder.hoTen);
			$("#inp-soDienThoai").val(paramResOrder.soDienThoai);
			$("#inp-email").val(paramResOrder.email);
			$("#inp-diaChi").val(paramResOrder.diaChi);

			$("#inp-loiNhan").val(paramResOrder.loiNhan);
			$("#inp-ngayTao").val(paramResOrder.ngayTao);
			$("#inp-ngayUpdate").val(paramResOrder.ngayCapNhat);

		}
	});
</script>
</html>